% ConstructionPart class:
% Consist of a physical object, its location and orientation in vessel body 
% frame and its contribution to the total moments of inertia of th vessel

% M ORDNE MULIGHET FOR VINKEL P OBJEKTET

classdef ConstructionPart
   properties
       part;    % Physical object
       x;   % x location of parts's the center of mass
       y;   % y location of parts's the center of mass
       z;   % z location of parts's the center of mass
       phi;
       theta;
       psi;
       R;
       I_contribution;
%        I_x_contribution;
%        I_y_contribution;
%        I_z_contribution;
   end
   methods
       function obj = ConstructionPart(part,x,y,z,phi,theta,psi)
           obj.part = part;
           obj.x = x;
           obj.y = y;
           obj.z = z;
           obj.phi = phi;
           obj.theta = theta;
           obj.psi = psi;
           r = [x, y, z]';
%            obj.phi = phi;
%            obj.theta = theta;
%            obj.psi = psi;
            % Rotational matrix (Euler angles):
            R = [cos(psi)*cos(theta), -sin(psi)*cos(phi)+cos(psi)*sin(theta)*sin(phi), sin(psi)*sin(phi)+cos(psi)*cos(phi)*sin(theta)
                sin(psi)*cos(theta), cos(psi)*cos(phi)+sin(phi)*sin(theta)*sin(psi), -cos(psi)*sin(phi)+sin(theta)*sin(psi)*cos(phi)
                -sin(theta), cos(theta)*sin(phi), cos(theta)*cos(phi)];
            obj.R = R;
           % Parallel axis theorem:
           obj.I_contribution = R*part.I*R' + part.mass*((r'*r)*eye(3) - r*r');
%            obj.I_x_contribution = (y^2 + z^2)*part.mass + part.I_x;
%            obj.I_y_contribution = (x^2 + z^2)*part.mass + part.I_y;
%            obj.I_z_contribution = (y^2 + x^2)*part.mass + part.I_z;
       end
       
%        function obj = plotXY(obj)
%           obj.part.plotXY(obj.x,obj.y,obj.R); 
%        end
%        function obj = plotXZ(obj)
%           obj.part.plotXZ(obj.x,-obj.z,obj.R); 
%        end
%        function obj = plotYZ(obj)
%           obj.part.plotYZ(obj.y,-obj.z,obj.R); 
%        end
       function obj = plotXY(obj,x0,y0)
          obj.part.plotXY(obj.x+x0,obj.y+y0,obj.R); 
       end
       function obj = plotXZ(obj,x0,z0)
          obj.part.plotXZ(obj.x+x0,-obj.z-z0,obj.R); 
       end
       function obj = plotYZ(obj,y0,z0)
          obj.part.plotYZ(obj.y+y0,-obj.z-z0,obj.R); 
       end
   end
end
