% Vessel construction

% Vurder  gjre medlemsvariablene ikke-endrbare utenfor klassen

classdef VesselConstruction < handle
   properties
       parts;
       mass = 0;
%        I_x = 0;
%        I_y = 0;
%        I_z = 0;
       I = zeros(3);
       CG_x = 0;
       CG_y = 0;
       CG_z = 0;
   end
   methods
%        function obj = VesselConstruction()
%        obj.parts = zeros(0,0);
%        end
       function obj = addPart(obj,part)
          obj.parts = [obj.parts, part];
         
          obj.CG_x = (obj.CG_x * obj.mass + part.x * part.part.mass)/(obj.mass + part.part.mass);
          obj.CG_y = (obj.CG_y * obj.mass + part.y * part.part.mass)/(obj.mass + part.part.mass);
          obj.CG_z = (obj.CG_z * obj.mass + part.z * part.part.mass)/(obj.mass + part.part.mass);
          
          obj.mass = obj.mass + part.part.mass;
          
          obj.I = obj.I + part.I_contribution;
%           obj.I_x = obj.I_x + part.I_x_contribution;
%           obj.I_y = obj.I_y + part.I_y_contribution;
%           obj.I_z = obj.I_z + part.I_z_contribution;
       end
       
       % Clear function
       function clearModel(obj)
           obj.parts = [];
           obj.mass = 0;
%            obj.I_x = 0;
%            obj.I_y = 0;
%            obj.I_z = 0;
           obj.CG_x = 0;
           obj.CG_y = 0;
           obj.CG_z = 0;
       end
       
       % Plot function
       function obj = plotVesselInPoint(obj,axis,x0,y0,z0)
%            figure()
          plot(0)
          if axis == 'xy'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotXY(x0,y0);
              end
          elseif axis == 'xz'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotXZ(x0,z0);
              end
          elseif axis == 'yz'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotYZ(y0,z0);
              end
          end
       end
       
       function obj = plotVessel(obj,axis,x0,y0,z0)
          figure()
          if axis == 'xy'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotXY(x0,y0);
              end
          elseif axis == 'xz'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotXZ(x0,z0);
              end
          elseif axis == 'yz'
              for i = 1:length(obj.parts)
                  obj.parts(i).plotYZ(y0,z0);
              end
          end
       end
       % 
%        function value = get.CG_x(obj)
%           numerator = 0;
%           denumerator = 0;
%           for i = 1:length(obj.parts)
%               numerator = numerator + obj.parts(i).x*obj.parts(i).part.mass;
%               denumerator = denumerator + obj.parts(i).part.mass;
%           end
%           value = numerator/denumerator;
%        end
   end
end