function D_foil = linearizedDampingMatrix_liftingFoils_2( foilData,foilLocation )

% Position coordinates
x = foilLocation(1);
y = foilLocation(2);
z = foilLocation(3);

% Coefficients
C_L_0 = foilData.C_L_0;
% C_D_0 = foilData.C_D_0;
C_L_alpha = foilData.C_L_alpha;
k = 2*C_L_0*C_L_alpha*foilData.k_C_D;
C_D_0 = C_L_0^2*foilData.k_C_D;

% Matrix
D_foil = -[(C_L_0 - k), y*(C_L_0 - k), -x*(C_L_0 - k)-2*z*C_D_0
    0,0,0
    -(C_D_0 + C_L_alpha), -y*(C_D_0 + C_L_alpha), x*(C_D_0 + C_L_alpha) - 2*z*C_L_0
    -y*(C_D_0 + C_L_alpha), -y^2*(C_D_0 + C_L_alpha), x*y*(C_D_0 + C_L_alpha) - 2*y*z*C_L_0
    z*(C_L_0 - k) + x*(C_D_0 + C_L_alpha), y*z*(C_L_0 - k) + y*x*(C_D_0 + C_L_alpha), -x*z*(C_L_0 - k) - 2*z^2*C_D_0 - x^2*(C_D_0 + C_L_alpha) + 2*x*z*C_L_0
    -x*y*(C_L_0 - k), y*y*(C_L_0 - k), -x*y*(C_L_0 - k)-2*y*z*C_D_0];

end