function plotData_3DOF_with_and_without_noise( eta, nu, nu_dot, delta, delta_c, eta2, nu2, nu_dot2, delta2, delta2_c)
r2d = 180/pi;
%% Declare variables

% Noise

t = eta.Time;

x = eta.Data(:,1);
y = eta.Data(:,2);
z = eta.Data(:,3);

u = nu.Data(:,1);
v = nu.Data(:,2);
w = nu.Data(:,3);

u_dot = nu_dot.Data(:,1);
v_dot = nu_dot.Data(:,2);
w_dot = nu_dot.Data(:,3);

phi = eta.Data(:,4)*r2d;
theta = eta.Data(:,5)*r2d;
psi = eta.Data(:,6)*r2d;

p = nu.Data(:,4)*r2d;
q = nu.Data(:,5)*r2d;
r = nu.Data(:,6)*r2d;

p_dot = nu_dot.Data(:,4)*r2d;
q_dot = nu_dot.Data(:,5)*r2d;
r_dot = nu_dot.Data(:,6)*r2d;

td = delta.Time;
d_a = delta.Data(:,1)*r2d;
d_e = delta.Data(:,2)*r2d;
d_z = delta.Data(:,3)*r2d;
% d_r = delta.Data(:,4)*r2d;

td_c = delta.Time;
d_a_c = delta_c.Data(:,1)*r2d;
d_e_c = delta_c.Data(:,2)*r2d;
d_z_c = delta_c.Data(:,3)*r2d;

% No noise:

t2 = eta2.Time;

x2 = eta2.Data(:,1);
y2 = eta2.Data(:,2);
z2 = eta2.Data(:,3);

u2 = nu2.Data(:,1);
v2 = nu2.Data(:,2);
w2 = nu2.Data(:,3);

u_dot2 = nu_dot2.Data(:,1);
v_dot2 = nu_dot2.Data(:,2);
w_dot2 = nu_dot2.Data(:,3);

phi2 = eta2.Data(:,4)*r2d;
theta2 = eta2.Data(:,5)*r2d;
psi2 = eta2.Data(:,6)*r2d;

p_dot2 = nu_dot2.Data(:,4)*r2d;
q_dot2 = nu_dot2.Data(:,5)*r2d;
r_dot2 = nu_dot2.Data(:,6)*r2d;

p2 = nu2.Data(:,4)*r2d;
q2 = nu2.Data(:,5)*r2d;
r2 = nu2.Data(:,6)*r2d;

td2 = delta2.Time;
d_a2 = delta2.Data(:,1)*r2d;
d_e2 = delta2.Data(:,2)*r2d;
d_z2 = delta2.Data(:,3)*r2d;
% d_r2 = delta2.Data(:,4)*r2d;

td2_c = delta2.Time;
d_a2_c = delta2_c.Data(:,1)*r2d;
d_e2_c = delta2_c.Data(:,2)*r2d;
d_z2_c = delta2_c.Data(:,3)*r2d;

% figure(1)
% plot(y,x)
% grid on
% title('Path')
% xlabel('East (m)')
% ylabel('North (m)')
% 


%% 3DOF Positions

figure(1)

subplot(3,1,1)
plot(t,z,t2,z2,'--')
grid on
title('Down Position')
xlabel('Time (s)')
ylabel('p_d (m)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(t,phi,t2,phi2,'--')
grid on
title('Roll Angle')
xlabel('Time (s)')
ylabel('\phi (deg)')
% legend('Noise on','Noise off')

subplot(3,1,3)
plot(t,theta,t2,theta2,'--')
grid on
title('Pitch Angle')
xlabel('Time (s)')
ylabel('\theta (deg)')
% legend('Noise on','Noise off')


%% 3DOF velocities

figure(2)

subplot(3,1,1)
plot(t,w,t2,w2,'--')
grid on
title('Heave Speed')
xlabel('Time (s)')
ylabel('w (m/s)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(t,p,t2,p2,'--')
grid on
title('Roll Rate')
xlabel('Time (s)')
ylabel('p (deg/s)')
% legend('Noise on','Noise off')

subplot(3,1,3)
plot(t,q,t2,q2,'--')
grid on
title('q')
title('Pitch Rate')
xlabel('Time (s)')
ylabel('q (deg/s)')
% legend('Noise on','Noise off')

%% 3DOF acceleration

figure(3)

subplot(3,1,1)
plot(t,w_dot,t2,w_dot2,'--')
grid on
title('Heave Acceleration')
xlabel('Time (s)')
ylabel('(m/s^2)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(t,p_dot,t2,p_dot2,'--')
grid on
title('Roll Acceleration')
xlabel('Time (s)')
ylabel('(deg/s^2)')
% legend('Noise on','Noise off')

subplot(3,1,3)
plot(t,q_dot,t2,q_dot2,'--')
grid on
title('Pitch Acceleration')
xlabel('Time (s)')
ylabel('(deg/s^2)')
% legend('Noise on','Noise off')

%% Controller angles

figure(4)

subplot(3,1,1)
plot(td,d_a,td2,d_a2,'--')
grid on
title('Roll Control Angle')
xlabel('Time (s)')
ylabel('\delta_a (deg)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(td,d_e,td2,d_e2,'--')
grid on
title('Pitch Control Angle')
xlabel('Time (s)')
ylabel('\delta_e (deg)')
% legend('Noise on','Noise off')

subplot(3,1,3)
plot(td,d_z,td2,d_z2,'--')
grid on
title('Heave Control Angle')
xlabel('Time (s)')
ylabel('\delta_z (deg)')
% legend('Noise on','Noise off')

% subplot(4,1,4)
% plot(td,d_r,td2,d_r2,'--')
% grid on
% title('\delta_r')
% xlabel('Time (s)')
% ylabel('(deg)')
% legend('Noise on','Noise off')

%% Controller inputs

figure(5)

subplot(3,1,1)
plot(td_c,d_a_c,td2_c,d_a2_c,'--')
grid on
title('Roll Control Input')
xlabel('Time (s)')
ylabel('\delta_a (deg)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(td_c,d_e_c,td2_c,d_e2_c,'--')
grid on
title('Pitch Control Input')
xlabel('Time (s)')
ylabel('\delta_e (deg)')
% legend('Noise on','Noise off')

subplot(3,1,3)
plot(td_c,d_z_c,td2_c,d_z2_c,'--')
grid on
title('Heave Control Input')
xlabel('Time (s)')
ylabel('\delta_z (deg)')
% legend('Noise on','Noise off')

%% Sway velocity and roll rate
figure(6)

subplot(3,1,1)
plot(t,psi,t2,psi2,'--')
grid on
title('Heading')
xlabel('Time (s)')
ylabel('\psi (deg)')
legend('Noise on','Noise off')

subplot(3,1,2)
plot(t,v,t2,v2,'--')
grid on
title('Sway Speed')
xlabel('Time (s)')
ylabel('v (m/s)')
legend('Noise on','Noise off')

subplot(3,1,3)
plot(t,r,t2,r2,'--')
grid on
title('Yaw Rate')
xlabel('Time (s)')
ylabel('r (deg/s)')
% legend('Noise on','Noise off')

end

